# TGCOMP -- Find the relative gain between two image sections
# By Doug Mink, SAO Telescope Data Center
# May 11, 2009

procedure tgcomp (images)

string	images = ""	{prompt="Input multispec image(s) to correct"}
string	imsect1="[245:500,1001:1256]"	{prompt="Section for amp 1 statistics"}
string	imsect2="[535:790,1001:1256]"	{prompt="Section for amp 2 statistics"}
bool	deltemp = yes	{prompt="Delete temporary file list (yes or no)"}
bool	verbose = yes	{prompt="Log progress (yes or no)"}

struct	*gainlist

begin
	bool vb
	file imin, templist, im1, im2
	string ims, is1, is2
	real mean1, mean2, mean12, med1, med2, med12

	vb = verbose
	is1 = imsect1
	is2 = imsect2

	tistat.images = "0311.DARK_med_0005_0007.fits[256:512,1001:1256]"
	tistat.fields = "image,npix,mean,median,stddev,min,max"
	tistat.lower = INDEF
	tistat.upper = INDEF
	tistat.nclip = 0
	tistat.lsigma = 3.
	tistat.usigma = 3.
	tistat.binwidth = 0.1
	tistat.imfile = ""
	tistat.npix = 0
	tistat.mean = 0.
	tistat.stddev = 0.
	tistat.median = 0.
	tistat.imode = 0.
	tistat.min = 0.
	tistat.max = 0.
	tistat.kurtosis = 0.
	tistat.skew = 0.
	tistat.print = vb
	tistat.format = yes
	tistat.cache = no


# If input image is a list prepend @ if not already there
	ims = images
        smatch (ims, ".list")
        if (smatch.found) {
            if (substr (ims,1,1) != '@')
		ims = "@" // ims
            }

#  Make temporary list of input files
        templist = mktemp ("tempgain") // ".list"
        files (ims, >templist)

# Flatten images from list one at a time
        gainlist = templist
	printf ("image        	mean1	mean2	ratio	median1	median2	ratio\n")
	printf ("-------------	-----	-----	-----	_______	_______	_____\n")
        while (fscan (gainlist,imin) != EOF) {
	    im1 = imin // is1
	    tistat (im1)
	    med1 = tistat.median
	    mean1 = tistat.mean
	    im2 = imin // is2
	    tistat (im2)
	    med2 = tistat.median
	    mean2 = tistat.mean
	    mean12 = mean1 / mean2
	    med12 = med1 / med2
	    printf ("%s	%.4f	%.4f	%.4f	%.4f	%.4f	%.4f\n", imin, mean1, mean2, mean12, med1, med2, med12)
	    }

	if (deltemp) {
	    delete (templist)
	    }
end

# May 11 2009	New task
