# TSDS9 - Run ds9 on local TRES image files, one file at a time
# October 5, 2009
# By Doug Mink, SAO Telescope Data Center

procedure tsds9 (images)

string	images=""	{prompt="Images to check"}

bool	background=yes	{prompt="Run in background (yes or no)"}
string	options=""	{prompt="DS9 command line options"}
int	maximages=4	{prompt="Maximum number of images to display in background"}
bool	deltemp=yes	{prompt="Delete intermediate image files (yes or no)"}
bool	verbose=yes	{prompt="Print process progress (yes or no)"}

begin

int	iext, nimg, maximg
file	templist, imin
string	ims, imlist, opt
bool	vb, first, bg

	vb = verbose
	ims = images
	first = yes
	bg = background
	opt = options
	maximg = maximages

	if (ims == "") {
	    print ("TSDS9:  Display TRES images using ds9")
	    print ("Usage: tsds9 <input sequence numbers>")
	    return
	    }

# If input image is a list prepend @ if not already there
	smatch (ims, ".list")
	if (smatch.found) {
	    if (substr (ims,1,1) != '@')
		ims = "@" // ims
	    }

#  Make temporary list of input files
	tsfiles.copyfile = no
	tsfiles.adddate = no
	tsfiles.keeppath = yes
	tsfiles.extension = ".fits"
	tsfiles (ims)
	if (tsfiles.nfiles == 0) {
	    delete (tsfiles.tempin)
	    if (vb)
		print ("TSDS9: No files found: ", ims)
	    return
	    }
	templist = tsfiles.tempout
	nimg = 0
	list = templist
        while (fscan (list,imin) != EOF) {
	    if (opt == "")
		args = imin
	    else
		args = opt // " " // imin 
	    nimg = nimg + 1
	    if (bg && nimg <= maximg)
		args = args // " &"
	    tds9 (args)
	    }

	if (deltemp) {
	    delete (templist)
	    delete (tsfiles.tempin)
	    }
end

# Oct  5 2009	New task based on TXDISP ->TXDS9 using TSFILES instead of TRSFILES
