# TXHEAD - Print headers of raw TRES FITS image files
# July 24, 2009
# By Doug Mink, SAO Telescope Data Center

procedure txhead (images)

string	images=""	{prompt="Images to check"}

bool	longheader=yes	{prompt="Print long header (yes or no)"}
bool	deltemp=yes	{prompt="Delete intermediate image files (yes or no)"}
bool	verbose=yes	{prompt="Print process progress (yes or no)"}

begin

int	iext, nimg
file	templist, imin
string	ims, imlist
bool	vb, lh

	vb = verbose
	ims = images
	lh = longheader

	if (ims == "") {
	    print ("TXHEAD:  Display raw TRES FITS image header")
	    print ("Usage: txdisp <input image sequence number or image filename> [options]")
	    return
	    }

    if (!deftask ("fxhead")) {
        fitsutil (motd=no)
        }

#  Make temporary list of input files
	trsfiles.copyfile = no
	trsfiles.adddate = no
	trsfiles.keeppath = yes
	trsfiles.extension = ".fits"
	trsfiles (ims)
	if (trsfiles.nfiles == 0) {
	    delete (trsfiles.tempin)
	    if (vb)
		print ("TXDISP: No files found: ", ims)
	    return
	    }
	templist = trsfiles.tempout
	nimg = 0
	list = templist
        while (fscan (list,imin) != EOF) {
	    args = imin
	    nimg = nimg + 1
	    if (vb && !lh)
		printf ("\n%s\n", imin)
	    fxhead (imin,long_header=lh)
	    }

	if (deltemp) {
	    delete (templist)
	    delete (trsfiles.tempin)
	    }
end

# Jul 24 2009	New task
